
--[[ XP Bar Functions ]]--

Xparky.XPBar = Xparky:inheritsFrom(Xparky.BaseBar, {
				BarType = "XP",
				Colours = {
					XPBar = { Red = 0, Green = 0.4, Blue = 0.9, Alpha = 1 },
					NoXPBar = { Red = 0.3, Green = 0.3, Blue = 0.3, Alpha = 1 },
					RestBar = { Red = 1, Green = 0.2, Blue = 1, Alpha = 1 },
				},
				Thickness = 8,
				Events = {"PLAYER_XP_UPDATE", "UPDATE_EXHAUSTION" },
				Rotate = 0,
				BarOrder = { [1] = "XPBar", [2] = "RestBar", [3] = "NoXPBar" },
				BarWidth = 900,
				Sections = {},
})

local XPBar = Xparky.XPBar

function XPBar:Setup(o)
	-- Bar
	Xparky:Print("creating XPBar")
	o = XPBar:create(o or {})
	o.Sections[1] = Xparky.SparkBar:Setup({Name = "XPBar"..o.Name, Colours = o.Colours.XPBar, Rotate = o.Rotate})
	o.Sections[2] = Xparky.BasicBar:Setup({Name = "RestBar"..o.Name, Colours = o.Colours.RestBar, Rotate = o.Rotate})
	o.Sections[3] = Xparky.BasicBar:Setup({Name = "NoXPBar"..o.Name, Colours = o.Colours.NoXPBar, Rotate = o.Rotate})
	o:ConstructBar()
	o:Update()
	return o
end

function XPBar:Update()
	local BarWidth
	local Attached = self.Attach and getglobal(self.Attach) or nil
	if not Attached then
		BarWidth = self.BarWidth
	else
		if self.Rotation == 0 or self.Rotation == 180 then
			BarWidth = Attached:GetWidth()
		else
			BarWidth = Attached:GetHeight()
		end
	end
	local Rest, CurrXP, MaxXP = GetXPExhaustion() or 0, UnitXP("player") or 0, UnitXPMax("player") or 0
	local Percent = (BarWidth/MaxXP)

	self.Sections[1]:Height(self.Thickness)
	self.Sections[2]:Height(self.Thickness)
	self.Sections[3]:Height(self.Thickness)
	
	self:Width(BarWidth)
	self:Height(self.Thickness)

	self.Sections[1]:Width(Percent * CurrXP)
	if Rest > (MaxXP - CurrXP) then
		self.Sections[2]:Width(Percent * (MaxXP - CurrXP))
		self.Sections[3]:Width(0)
	else
		self.Sections[2]:Width(Percent * Rest)
		self.Sections[3]:Width(Percent * (MaxXP-CurrXP))
	end

	self.Sections[2].Base:SetFrameLevel(self.Sections[1].Base:GetFrameLevel() - 1)
	self.Anchor:SetFrameLevel(self.Sections[3].Base:GetFrameLevel() + 1)
end

